var currentListSort;
var currentListAscend = 1;
var listSearchText = "";

function loadList() {
	loadXMLDoc(docUrl,processChangeList);
}

function processChangeList() {
    if (req.readyState == 4) {
    	var strVal;
        if (req.status == 200) {
        	generateItems();
			var feedAddress = getElementTextNS("wordcast", info[0], 0);
			if ((feedAddress != "") && (feedAddress != null)) {
				document.getElementById("feed").className = "visible";
				document.links[document.links.length-1].href = feedAddress;
			}
			document.title = rawGetElementTextNS("title", info[0], 0);
			div = document.getElementById("creator");
			div.innerHTML = rawGetElementTextNS("author", info[0], 0);
			if (readCookie('sortAscend') == '-1')
				currentListAscend = -1;
			var sortCookie = readCookie('sortName');
			if (sortCookie)
        		sortListBy(sortCookie);
			else
    			sortListBy("_num");
         } else {
       	 	div = document.getElementById("list");
     	    div.innerHTML = "<tr><td>There was an error with the file:\n" + req.statusText+"</td></tr>";
         }
    }
}

function displayList() {
	strVal = "<tr><th align='right'><a onclick='sortListBy(\"_num\");' href='#'>#</a><img id='sort_num' src='images/blank.gif' style='background-color: black;' /></th>";
	for (var i = 0; i < languages.length; i++) {
		if (languageTypes[languages[i]] == "text")
			strVal += "<th><a onclick='sortListBy(\"" + languages[i] + "\");' href='#'>" + languages[i] + "</a><img id='sort" + languages[i] + "' src='images/blank.gif' style='background-color: black;' /></th>";
		else
			strVal += "<th>" + languages[i] + "<img id='sort" + languages[i] + "' src='images/blank.gif' style='background-color: black;' /></th>";
	}
	strVal += "</tr>";
	for (var i = 0; i < words.length; i++) {
		if (words[i]["_color"] != null)
			strVal += "<tr style='color: rgb(" + words[i]["_color"] + ");'><td class='numbers'>" + words[i]["_num"] + ". </td>";
		else
			strVal += "<tr><td class='numbers'>" + words[i]["_num"] + ". </td>";
		for (var j = 0; j < languages.length; j++) {
			strVal += "<td class='language" + languages[j];
			if (languageTypes[languages[j]] == "text")
				strVal +=  "'>" + textForLang(i,j) + "</td>";
			else if (languageTypes[languages[j]] == "image")
				strVal += "' style='text-align: center;'><img src='" + textForLang(i,j) + "' alt='' />" + "</td>";
			else
				strVal += "'><a href='#' onclick='playAudio(\"" + textForLang(i,j) + "\");'><img src='images/play.png' alt='Play Audio' /></a>" + "</td>";
		}
		strVal += "</tr>";
	}
	div = document.getElementById("list");
	div.innerHTML = strVal;
	strVal = words.length;
	if (words.length != allWords.length)
		strVal += " of " + allWords.length + " words";
	else if (words.length == 1)
		strVal = "1 word";
	else
		strVal += " words";
	div = document.getElementById("count");
	div.innerHTML = strVal;
	for (var i = 0; i < languages.length; i++)
		setStyleByClass("*","language" + languages[i],"font",fontSizes[i] + "pt " + fonts[i]);
}

function sortListBy(lang) {
	if (currentListSort != lang) {
		currentListSort = lang;
	} else
		currentListAscend = -currentListAscend;
	createCookie('sortName',currentListSort);
	createCookie('sortAscend',currentListAscend);
	doListSearch();
	words.sort(listSort);
	displayList();
	if (currentListAscend == 1)
		document.getElementById("sort" + currentListSort).src = "images/ascend.gif";
	else
		document.getElementById("sort" + currentListSort).src = "images/descend.gif";
}

function doListSearch() {
	if (!listSearchText || (listSearchText == ""))
		words = allWords;
	else {
	// cache old value to speed up if its overlap (ie "sm" -> "sma")
		words = new Array();
		var current = 0;
		for (var i = 0; i < allWords.length; i++) {
			for (var j = 0; j < languages.length; j++) {
				if ((languageTypes[languages[j]] == "text") && (rawWords[i][languages[j]]) && (allWords[i][languages[j]].indexOf(listSearchText) != -1)) {
					words[current] = allWords[i];
					current++;
					break;
				}
			}
		}
	}
}

function updateListSearch(searchField) {
	var searchText = searchField.value.toLowerCase();
	if (searchText != listSearchText) {
		listSearchText = searchText;
		doListSearch();
		displayList();
		if (currentListAscend == 1)
			document.getElementById("sort" + currentListSort).src = "images/ascend.gif";
		else
			document.getElementById("sort" + currentListSort).src = "images/descend.gif";
	}
}

function listSort(first,second) {
	var firstVal = first[currentListSort];
	var secondVal = second[currentListSort];
	if (currentListSort != "_num") {
		firstVal = firstVal.toLowerCase();
		secondVal = secondVal.toLowerCase();
	}
	if (firstVal == secondVal)
		return 0;
	else if (firstVal < secondVal)
		return -currentListAscend;
	return currentListAscend;
}

